SystemOrganization addCategory: #ConfigurationOfVolunti!

Object subclass: #ConfigurationOfVolunti
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfVolunti'!

!ConfigurationOfVolunti class methodsFor: 'development support' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfVolunti class methodsFor: 'private' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfVolunti class methodsFor: 'private' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfVolunti class methodsFor: 'private' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfVolunti class methodsFor: 'metacello tool support' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfVolunti class methodsFor: 'loading' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfVolunti class methodsFor: 'loading' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfVolunti class methodsFor: 'loading' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfVolunti class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
project

	^self new project! !

!ConfigurationOfVolunti class methodsFor: 'development support' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfVolunti methodsFor: 'baselines' stamp: 'NicolasVanderAuwera 5/4/2012 08:22'!
baseline01: spec
	<version: '0.1-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://www.squeaksource.com/Volunti' username: 'nvda' password: 'L!!nC+A$m'.
			spec
				package: 'SSL' with: [ spec repository: 'http://www.squeaksource.com/Cryptography' ];
				package: 'Cryptography' with: [ spec repository: 'http://www.squeaksource.com/Cryptography' ].
			"spec
				project: 'SeasideCore'
				with: [ 
					spec
						className: 'ConfigurationOfSeaside30';
						versionString: #stable;
						repository: 'http://www.squeaksource.com/MetacelloRepository' ]."
			spec
				project: 'JQueryMobile'
				with: [ 
					spec
						className: 'ConfigurationOfJQueryMobile';
						file: 'ConfigurationOfJQueryMobile';
						versionString: #bleedingEdge;
						repository: 'http://ss3.gemstone.com/ss/jQueryMobile' ].
			spec
				project: 'XMLSupport'
				with: [ 
					spec
						className: 'ConfigurationOfXMLSupport';
						file: 'ConfigurationOfXMLSupport';
						versionString: '1.0.3';
						repository: 'http://www.squeaksource.com/XMLSupport/' ].
			spec package: 'Volunti' with: [ spec requires: #('SSL' 'Cryptography'" 'SeasideCore'" 'JQueryMobile' 'XMLSupport') ] ]! !

!ConfigurationOfVolunti methodsFor: 'baselines' stamp: 'NicolasVanderAuwera 12/16/2012 09:54'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec author: 'nvda'.
			spec timestamp: '31/10/2012 14:40'.
			spec repository: 'http://ss3.gemstone.com/ss/iVolunti'.
			spec
				package: 'SSL' with: [ spec repository: 'http://www.squeaksource.com/Cryptography' ];
				package: 'Cryptography' with: [ spec repository: 'http://www.squeaksource.com/Cryptography' ];
				package: 'TreeCounting' with: [ spec repository: 'http://ss3.gemstone.com/ss/TreeCounting' ].
			spec
				project: 'PaillierThreshold'
				with: [ 
					spec
						className: 'ConfigurationOfPaillierThreshold';
						file: 'ConfigurationOfPaillierThreshold';
						versionString: #stable;
						repository: 'http://ss3.gemstone.com/ss/PaillierThreshold' ].
			spec
				project: 'XMLWriter'
				with: [ 
					spec
						className: 'ConfigurationOfXMLWriter';
						file: 'ConfigurationOfXMLWriter';
						versionString: '1.0.5';
						repository: 'http://www.squeaksource.com/XMLWriter' ].
			spec
				project: 'Magritte3'
				with: [ 
					spec
						className: 'ConfigurationOfMagritte3';
						file: 'ConfigurationOfMagritte3';
						versionString: #stable;
						loads: #('Core' 'Seaside');
						repository: 'http://source.lukas-renggli.ch/magritte3' ].
			spec
				project: 'jQueryMobile'
				with: [ 
					spec
						className: 'ConfigurationOfJQueryMobile';
						file: 'ConfigurationOfJQueryMobile';
						versionString: #bleedingEdge;
						repository: 'http://ss3.gemstone.com/ss/jQueryMobile' ].
			spec
				project: 'TwitterBootstrap'
				with: [ 
					spec
						className: 'ConfigurationOfTwitterBootstrap';
						versionString: #stable;
						loads: #('Twitter-Bootstrap-Magritte');
						repository: 'http://ss3.gemstone.com/ss/TwitterBootstrap' ].
			spec
				package: 'Volunti' with: [ spec requires: #('SSL' 'Cryptography' 'XMLWriter' 'Magritte3' 'TwitterBootstrap') ];
				package: 'Volunti-Common'
					with: [ spec requires: #('SSL' 'Cryptography' 'XMLWriter' 'Magritte3' 'TwitterBootstrap') ];
				package: 'Volunti-Urn' with: [ spec requires: #('Volunti-Ballot') ];
				package: 'Volunti-GenerationServers' with: [ spec requires: #('Volunti-Common') ];
				package: 'Volunti-AnonymousAuthority' with: [ spec requires: #('Volunti-Common') ];
				package: 'Volunti-HomomorphicAuthority' with: [ spec requires: #('Volunti-Common' 'PaillierThreshold') ];
				package: 'Volunti-MentalBoothAuthority' with: [ spec requires: #('Volunti-Common') ];
				package: 'Volunti-RegistrationOffice' with: [ spec requires: #('Volunti-Common') ];
				package: 'Volunti-MPDVS' with: [ spec requires: #('Volunti-Common') ];
				package: 'Volunti-PublicBoard'
					with: [ spec requires: #('Volunti-Common' 'PaillierThreshold' 'Volunti-Urn' 'TreeCounting') ];
				package: 'Volunti-PollingOffice' with: [ spec requires: #('Volunti-Common' 'PaillierThreshold' 'Volunti-Urn') ];
				package: 'Volunti-CertificationAuthority' with: [ spec requires: #('Volunti-Common') ];
				package: 'Volunti-ElectionManager' with: [ spec requires: #('Volunti-Common') ];
				package: 'Volunti-ElectionClient' with: [ spec requires: #('Volunti-Common' 'Volunti-Ballot' 'jQueryMobile') ].
			spec
				group: 'default' with: #('Core');
				group: 'Core'
					with:
						#('AnonymousAuthority' 'HomomorphicAuthority' 'CertificationAuthority' 'MPDVS' 'RegistrationOffice' 'MentalBoothAuthority' 'PublicBoard' 'PollingOffice' 'ElectionClient' 'ElectionManager' 'GenerationServers');
				group: 'AnonymousAuthority' with: #('Volunti-AnonymousAuthority');
				group: 'HomomorphicAuthority' with: #('Volunti-HomomorphicAuthority');
				group: 'CertificationAuthority' with: #('Volunti-CertificationAuthority');
				group: 'MPDVS' with: #('Volunti-MPDVS');
				group: 'RegistrationOffice' with: #('Volunti-RegistrationOffice');
				group: 'MentalBoothAuthority' with: #('Volunti-MentalBoothAuthority');
				group: 'PublicBoard' with: #('Volunti-PublicBoard');
				group: 'PollingOffice' with: #('Volunti-PollingOffice');
				group: 'ElectionClient' with: #('Volunti-ElectionClient');
				group: 'ElectionManager' with: #('Volunti-ElectionManager');
				group: 'GenerationServers' with: #('Volunti-GenerationServers') ]! !

!ConfigurationOfVolunti methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfVolunti methodsFor: 'symbolic versions' stamp: 'NicolasVanderAuwera 10/31/2012 10:39'!
stable: spec
	<symbolicVersion: #stable>
	spec for: #common version: '1.0'! !

!ConfigurationOfVolunti methodsFor: 'versions' stamp: 'NicolasVanderAuwera 5/4/2012 07:22'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #development.
			spec author: 'Nicolas Vander Auwera'.
			spec timestamp: '27/04/2012 09:26'.
			spec
				package: 'Cryptography' with: 'Cryptography-mtf.36';
				package: 'SSL' with: 'SSL-cds.18';
				package: 'Volunti' with: 'Volunti-NicolasVanderAuwera.44' ]! !

!ConfigurationOfVolunti methodsFor: 'versions' stamp: 'NicolasVanderAuwera 5/4/2012 10:18'!
version02: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #development.
			spec author: 'Nicolas Vander Auwera'.
			spec timestamp: '27/04/2012 09:26'.
			spec
				package: 'Cryptography' with: 'Cryptography-mtf.36';
				package: 'SSL' with: 'SSL-cds.18';
				package: 'Volunti' with: 'Volunti-NicolasVanderAuwera.47' ]! !

!ConfigurationOfVolunti methodsFor: 'versions' stamp: 'NicolasVanderAuwera 8/22/2012 15:23'!
version03: spec
	<version: '0.3' imports: #('0.1-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #development.
			spec author: 'Nicolas Vander Auwera'.
			spec timestamp: '27/04/2012 09:26'.
			spec
				package: 'Cryptography' with: 'Cryptography-mtf.36';
				package: 'SSL' with: 'SSL-cds.18';
				package: 'Volunti' with: 'Volunti-NicolasVanderAuwera.90' ]! !

!ConfigurationOfVolunti methodsFor: 'versions' stamp: 'NicolasVanderAuwera 10/31/2012 16:54'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #development.
			spec description: 'Last version of each package is loaded for the stable version.'.
			spec author: 'Nicolas Vander Auwera'.
			spec timestamp: '31/10/2012 09:16' ]! !
